/******************************************************************************
Ootake
EVistaAEROɑΉ邽߁ADirect3Dł̕`BA@\Iɂ
  ScreenDD.c(DirectDraw`)ƓBJ[32rbĝݑΉƂB

Copyright(C)2006-2009 Kitao Nakamura.
	ŁEpłJȂƂ͕K\[XR[hYtĂB
	̍ۂɎł܂܂̂ŁAЂƂƂm点ƍKłB
	Iȗp͋ւ܂B
	Ƃ́uGNU General Public License(ʌOp_)vɏ܂B

******************************************************************************/
#define _CRT_SECURE_NO_DEPRECATE

#define DIRECT3D_VERSION	0x0900

#define SOURCE_PITCH 		512

#include <D3D9.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include "ScreenD3D.h"
#include "Screen.h"
#include "WinMain.h"
#include "App.h"
#include "MainBoard.h"
#include "math.h"
#include "Printf.h"

static LPDIRECT3D9				_pD3D = NULL; //Direct3D object
static LPDIRECT3DDEVICE9		_pD3DDev = NULL; //foCX
static LPDIRECT3DSURFACE9		_pD3DSBack = NULL; //obNobt@(ɓ]Ǝۂɕ`悳)
static LPDIRECT3DSURFACE9		_pD3DSGame = NULL; //Cʗp
static LPDIRECT3DSURFACE9		_pD3DSText = NULL; //eLXgbZ[Wp
static LPDIRECT3DSURFACE9		_pD3DSFps = NULL; //FPS\p
static D3DPRESENT_PARAMETERS	_pD3DParam;

static LONG		_SurfacePitch = 0;

static Sint32	_Width;
static Sint32	_Height;
static Sint32	_Magnification;
static Uint32	_Flags;
static HWND		_hWnd;
static Uint16*	_pScreenPixels;
static BOOL		_bChangedFullScreen = FALSE;
static Sint32	_GameLeft;   //print_message()ŕ\ʒû߂ɁAQ[ʓ]̍WTĂB
static Sint32	_GameRight;  //
static Sint32	_GameTop;    //
static Sint32	_GameBottom; //

//Win9xpϐ
static DWORD	_PrevWidth;
static DWORD	_PrevHeight;
static DWORD	_PrevBitsPerPixel;
static DWORD	_PrevFrequency;

static DWORD	_LastTimeSyncTime; //OSyncƂ̃^C}[JEg
static Sint32	_SyncAjust; //VSyncIt̂Ƃ1/60bԊuɂł邾߂Â邽߂̕ϐBv1.67
static BOOL		_bSyncTo60HzScreen = TRUE;

static Uint32	_Gamma[8]; //K}vZlĂBv1.14BUint32ɂقB
static Uint32	_GammaS80[8]; //XLC80%p
static Uint32	_GammaS85[8]; //XLC85%p
static Uint32	_GammaS90[8]; //XLC90%p
static Uint32	_GammaS95[8]; //XLC95%p

static LONG		_Pitch;
static LONG		_PitchHalf; //pitch̔ĂBxAbvpB
static Uint16*	_pPixels;

static char*	_pMessageText = ""; //eLXgbZ[W\pobt@Bki擪0j̏ꍇA\B


//D3DfoCX̊J
static void
d3dSurfaceRelease()
{
	if (_pD3DSFps != NULL)
	{	_pD3DSFps->Release();	_pD3DSFps = NULL;	}

	if (_pD3DSText != NULL)
	{	_pD3DSText->Release();	_pD3DSText = NULL;	}

	if (_pD3DSGame != NULL)
	{	_pD3DSGame->Release();	_pD3DSGame = NULL;	}

	if (_pD3DSBack != NULL)
	{	_pD3DSBack->Release();	_pD3DSBack = NULL;	}
}

//Direct3DpXN[SɊJ܂B
void
SCREEND3D_Deinit()
{
	if (_pD3D != NULL)
	{
		d3dSurfaceRelease();
		if (_pD3DDev != NULL)
		{
			_pD3DDev->Release();
			_pD3DDev = NULL;
		}
		_pD3D->Release();
		_pD3D = NULL;
	}
}

static HRESULT
d3dDevReset()
{
	int			a;
	HRESULT		hr;

	if (_pD3DDev == NULL) //쐬̏ꍇ
	{
		hr = _pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, _hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING,
								 &_pD3DParam, &_pD3DDev);
	}
	else //łɍ쐬ς݂̏ꍇ
	{
		d3dSurfaceRelease();
		hr = _pD3DDev->Reset(&_pD3DParam);
		if (FAILED(hr)) //ZbgɎs蒼
		{
			_pD3DDev->Release();
			_pD3DDev = NULL;
			hr = _pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, _hWnd, D3DCREATE_SOFTWARE_VERTEXPROCESSING,
									 &_pD3DParam, &_pD3DDev);
		}
	}
	if (FAILED(hr))
		return hr;

	//obNobt@[̃AhX擾
	_pD3DDev->GetBackBuffer(0, 0, D3DBACKBUFFER_TYPE_MONO, &_pD3DSBack);

    //C(Q[)ʕ\pItXN[T[tFX쐬
	if (_Magnification == 1)
		a = 512 + 8; //+8͉E[ɃNA}[WݗpBDirect3Dł͉E[ŃNAĂȂƃtB^̃oCg܂ŎQƂ̂ŉE[邱Ƃ悤Bv2.06XVB+1ővƎvÔ8̔{ɂB
	else //2{ȏ͑Sĉ2{BxAbv{邱ƂœKxɃoCjAtB^|肢ɂȂ
		a = 512*2 + 8; //+8͉E[ɃNA}[WݗpBDirect3Dł͉E[ŃNAĂȂƃtB^̃oCg܂ŎQƂ̂ŉE[邱Ƃ悤Bv2.06XVB+1ővƎvÔ8̔{ɂB
	_pD3DDev->CreateOffscreenPlainSurface(a, 256*_Magnification, D3DFMT_X8R8G8B8, D3DPOOL_DEFAULT, &_pD3DSGame, NULL); //D3DPOOL_DEFAULTɂȂStretchRectgȂB

    //eLXg\pItXN[T[tFX쐬
	_pD3DDev->CreateOffscreenPlainSurface(512*2, 32, D3DFMT_X8R8G8B8, D3DPOOL_DEFAULT, &_pD3DSText, NULL);

    //FPS\pItXN[T[tFX쐬
	_pD3DDev->CreateOffscreenPlainSurface(64*2, 32, D3DFMT_X8R8G8B8, D3DPOOL_DEFAULT, &_pD3DSFps, NULL);

	return hr;
}

//Direct3DpXN[܂B
BOOL
SCREEND3D_Init(
	Sint32		width,
	Sint32		height,
	Sint32		magnification,
	Uint32		flags)
{
	DEVMODE					dm;
	D3DDISPLAYMODE			dmode;
	HRESULT					hr;

	//p[^ۊ
	_Width = width;
	_Height = height;
	_Magnification = magnification;
	_Flags = flags;
	_hWnd =	WINMAIN_GetHwnd();

	_pD3D = Direct3DCreate9(D3D_SDK_VERSION);
	if (_pD3D == NULL)
	{
		MessageBox(_hWnd, "ERROR: DIRECT3D::Direct3DCreate9() failed.    ", "Ootake", MB_OK);
		return FALSE;
	}

	//tXN[̏ꍇA ʂ̉𑜓xݒ肵AEBhEɔzuʑS̑傫ɂB
	//	Direct3D9̃tXN[[h́Aj[⑼̃_CAO\ɏoȂ̂ŎgȂB蓮ŃtXN[ɐ؂ւĂEBhE[hgB
	//										 ^C}[̐iݕȂsAEBhE[hȂłB
	if (flags & SCREEN_FFULLSCREEN) //tXN[[hȂ
	{
		if (APP_GetWindows9x()) //Windows98/MȅꍇACDS_FULLSCREENȂAfXNgbvɖ߂Ȃ̂ŁA蓮Ōɖ߂ߕύXO̐ݒޔĂB
			if (_bChangedFullScreen == FALSE) //EBhE(fXNgbv)tXN[ւ̐؂ւ
			{
				memset(&dm, 0, sizeof(DEVMODE));
				dm.dmSize = sizeof(DEVMODE);
				EnumDisplaySettings(NULL, ENUM_CURRENT_SETTINGS, &dm);
				_PrevWidth = dm.dmPelsWidth;
				_PrevHeight = dm.dmPelsHeight;
				_PrevBitsPerPixel = dm.dmBitsPerPel;
				_PrevFrequency = dm.dmDisplayFrequency;
			}
		memset(&dm, 0, sizeof(DEVMODE));
		dm.dmSize = sizeof(DEVMODE);
		dm.dmPelsWidth = width;
		dm.dmPelsHeight = height;
		dm.dmBitsPerPel = 32;
		dm.dmDisplayFrequency = 60;
		dm.dmFields = DM_PELSWIDTH | DM_PELSHEIGHT | DM_BITSPERPEL | DM_DISPLAYFREQUENCY;
		ChangeDisplaySettings(&dm, CDS_FULLSCREEN);
		_bChangedFullScreen = TRUE;
	}
	else //EBhE[hȂ
	{
		if (_bChangedFullScreen) //tXN[EBhEւ̐؂ւ
		{
			if (APP_GetWindows9x()) //Windows98/MȅꍇACDS_FULLSCREENȂAŃfXNgbv̏Ԃɖ߂Ȃ̂ŁA蓮Ōɖ߂B
			{
				memset(&dm, 0, sizeof(DEVMODE));
				dm.dmSize = sizeof(DEVMODE);
				dm.dmPelsWidth = _PrevWidth;
				dm.dmPelsHeight = _PrevHeight;
				dm.dmBitsPerPel = _PrevBitsPerPixel;
				dm.dmDisplayFrequency = _PrevFrequency;
				dm.dmFields = DM_PELSWIDTH | DM_PELSHEIGHT | DM_BITSPERPEL | DM_DISPLAYFREQUENCY;
				ChangeDisplaySettings(&dm, 0);		
			}
			else //Windows XP/2000/Vistaȍ~̏ꍇ	
				ChangeDisplaySettings(NULL, 0); //fXNgbvɖ߂
			Sleep(1000); //fXNgbvɖ߂܂ŔÔ߂ɃEFCgBDirecDraŵƂ̂悤Direct3D̃foCX̍쐬sȂ̂ŁB
		}
		_bChangedFullScreen = FALSE;
	}

	//fBXvC[h擾BWindow[hɂVSync\ǂ̔fs߂ɗp
	_pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &dmode);

	//Direct3DfoCX쐬Bj[_CAO\̂߁AtXN[EBhEfoCXƂč쐬B
	ZeroMemory(&_pD3DParam, sizeof(_pD3DParam));
	_pD3DParam.hDeviceWindow = _hWnd;
	_pD3DParam.BackBufferWidth = width;
	_pD3DParam.BackBufferHeight = height;
	_pD3DParam.BackBufferFormat = D3DFMT_X8R8G8B8; //32rbgJ[p
	_pD3DParam.BackBufferCount = 1;
	_pD3DParam.Windowed = TRUE; //Window[hBQlFWinodwedTRUÊƂɃtbV[gݒ肷CreateG[
	if ((APP_GetSyncTo60HzScreen())&&((dmode.RefreshRate == 60)||(dmode.RefreshRate == 0))) //tbV[g60Hz0(K)̂ƂVSyncOKɁB
	{
		_pD3DParam.SwapEffect = D3DSWAPEFFECT_DISCARD; //COPYy
		_pD3DParam.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
		//D3DSWAPEFFECT_FLIPɂācD3DSWAPEFFECT_DISCARD(COPY)ɂĎ蓮VSyncA]Ȃ邽߂CPUւׂ͌̕y
		//							  ̃^C~OxƂď(mCYڂ)₷悤Ȃ̂ŁADISCARD+IMMEDIATEōsB
		//_pD3DParam.SwapEffect = D3DSWAPEFFECT_FLIP;
		//_pD3DParam.PresentationInterval = D3DPRESENT_INTERVAL_ONE;
	}
	else
	{
		_pD3DParam.SwapEffect = D3DSWAPEFFECT_DISCARD; //COPYy
		_pD3DParam.PresentationInterval = D3DPRESENT_INTERVAL_IMMEDIATE;
	}
	_pD3DParam.Flags = D3DPRESENTFLAG_LOCKABLE_BACKBUFFER;
	hr = d3dDevReset(); //쐬
	if (FAILED(hr))
	{
		MessageBox(_hWnd, "ERROR: DIRECT3D::CreateDevice() failed.    ", "Ootake", MB_OK);
		SCREEND3D_Deinit();
		return FALSE;
	}

	//K}i邳jvZς݂̃e[upӁB
	SCREEND3D_SetGamma(APP_GetScanLineType(), APP_GetScanLineDensity(), APP_GetTvMode());

	_LastTimeSyncTime = 0; //OSyncƂ̃^C}[JEg
	_SyncAjust = 0; //VSyncIt̂Ƃ1/60bԊuɂł邾߂Â邽߂̕ϐBv1.67

	//ʂNA
	SCREEND3D_Clear();

	return TRUE;
}


//K}i邳jvZς݂̃e[upӁB
void
SCREEND3D_SetGamma(
	Sint32	scanLineType,
	Sint32	scanLineDensity, //XLC̔ZxB0c^(0%)B1c50%B2cm[}(80%)
	BOOL	bTvMode)
{
	int 	a,i;
	double	d = APP_GetGammaValue(); //cXLC̊{K}l
	Sint32	b = APP_GetBrightValue(); //uCglX

	if ((APP_GetFullStretched())&&(_Flags & SCREEN_FFULLSCREEN)) //tXgb`[hȂBv1.24ǉ
		scanLineType = 0; //掿ۂ߃mXLC

	if (bTvMode)
	{
		if ((scanLineType != 0)&&(_Magnification >= 2)) //TV Mode x2,x3,x4̂Ƃ
			scanLineType = 4;
	}
	else
	{
		if (scanLineType == 4) //X^[gTV Mode ݒ肵ĂāATvModeꎞIFALSȄԂȂ
			scanLineType = 1; //XyV(c)XLCŕ`
	}

	if ((scanLineType != 0)&&(_Magnification >= 2)) //XLC̏ꍇAXLCňÂȂԂAK}𖾂߂ɁB
	{
		switch (scanLineType)
		{
			case 1: //cXLC
				break;
			case 2: //XLC
			case 3: //cXLC()
			case 4: //TV Mode
				d = (1-15/800)*d; // (1-15/800)*1.305 cƔׂĖ邢Ԃ
				switch (scanLineDensity)
				{
					case 0:
						d = d * 1.4; //40%_E邳グ
						break;
					case 20:
						d = d * 1.3; //30%_E邳グ
						break;
					case 40:
						d = d * 1.2; //20%_E邳グ
						break;
				}
				break;
			default:
				d = (1-95/800)*d;
				break;
		}
	}
	else //mXLCx1̏ꍇ
		d = (1-95/800)*d; // (1-95/800)*1.305 cƔׂĖ邢Ԃ

	if ((scanLineType>=2)&&(scanLineType<=4)&&(scanLineDensity==0)) //XLC0%
	{
		for (i=0; i<=7 ; i++)
		{
			if (i == 0)
				a = 0; //͐^
			else
				a = (i << 5) + b; //+1B͈͂ŏ߂ɂقڂɂȂB
			_Gamma[i] = (Uint32)((pow((double)a / 256.0, 1.0/d) * 256.0) +0.5);
			_GammaS80[i] = 0; //^
			_GammaS85[i] = 0; //^
			_GammaS90[i] = (Uint32)((pow((double)a*0.50 / 256.0, 1.0/d) * 256.0) +0.5); //XLC50%p
			_GammaS95[i] = (Uint32)((pow((double)a*0.50 / 256.0, 1.0/d) * 256.0) +0.5); //XLC50%p
		}
	}
	else if ((scanLineType>=2)&&(scanLineType<=4)&&(scanLineDensity==20)) //XLC20%
	{
		for (i=0; i<=7 ; i++)
		{
			if (i == 0)
				a = 0; //͐^
			else
				a = (i << 5) + b; //+1B͈͂ŏ߂ɂقڂɂȂB
			_Gamma[i] = (Uint32)((pow((double)a / 256.0, 1.0/d) * 256.0) +0.5);
			_GammaS80[i] = (Uint32)((pow((double)a*0.20 / 256.0, 1.0/d) * 256.0) +0.5); //XLC20%p
			_GammaS85[i] = (Uint32)((pow((double)a*0.40 / 256.0, 1.0/d) * 256.0) +0.5); //XLC40%p
			_GammaS90[i] = (Uint32)((pow((double)a*0.60 / 256.0, 1.0/d) * 256.0) +0.5); //XLC60%p
			_GammaS95[i] = (Uint32)((pow((double)a*0.80 / 256.0, 1.0/d) * 256.0) +0.5); //XLC80%p
		}
	}
	else if ((scanLineType>=2)&&(scanLineType<=4)&&(scanLineDensity==40)) //XLC40%
	{
		for (i=0; i<=7 ; i++)
		{
			if (i == 0)
				a = 0; //͐^
			else
				a = (i << 5) + b; //+1B͈͂ŏ߂ɂقڂɂȂB
			_Gamma[i] = (Uint32)((pow((double)a / 256.0, 1.0/d) * 256.0) +0.5);
			_GammaS80[i] = (Uint32)((pow((double)a*0.40 / 256.0, 1.0/d) * 256.0) +0.5); //XLC40%p
			_GammaS85[i] = (Uint32)((pow((double)a*0.55 / 256.0, 1.0/d) * 256.0) +0.5); //XLC55%p
			_GammaS90[i] = (Uint32)((pow((double)a*0.70 / 256.0, 1.0/d) * 256.0) +0.5); //XLC70%p
			_GammaS95[i] = (Uint32)((pow((double)a*0.85 / 256.0, 1.0/d) * 256.0) +0.5); //XLC85%p
		}
	}
	else //scanLineDensity==80BXLC80%܂͉XLCȊȌꍇB
	{
		for (i=0; i<=7 ; i++)
		{
			if (i == 0)
				a = 0; //͐^
			else
				a = (i << 5) + b; //+1B͈͂ŏ߂ɂقڂɂȂB
			_Gamma[i] = (Uint32)((pow((double)a / 256.0, 1.0/d) * 256.0) +0.5);
			_GammaS80[i] = (Uint32)((pow((double)a*0.80 / 256.0, 1.0/d) * 256.0) +0.5); //XLC80%p
			_GammaS85[i] = (Uint32)((pow((double)a*0.85 / 256.0, 1.0/d) * 256.0) +0.5); //XLC85%p
			_GammaS90[i] = (Uint32)((pow((double)a*0.90 / 256.0, 1.0/d) * 256.0) +0.5); //XLC90%p
			_GammaS95[i] = (Uint32)((pow((double)a*0.95 / 256.0, 1.0/d) * 256.0) +0.5); //XLC95%p
		}
	}
}


//XN[[hύX܂B 
BOOL
SCREEND3D_ChangeMode(
	Sint32		width,
	Sint32		height,
	Sint32		magnification,
	Uint32		flags)
{
	SCREEND3D_Deinit();
	return SCREEND3D_Init(width, height, magnification, flags);
}


//AԂ҂܂B(VSync)
BOOL
SCREEND3D_WaitVBlank(
	BOOL	bDraw) //bDrawTRUEɂČĂԂƕ`sBFALSȄꍇVSync҂̂݁B
{
	Sint32				t;
	D3DRASTER_STATUS	rs;
	HRESULT				hr;

	//Vista"Aero""VistaX^_[h(Home Basicɂ̂ݑ)"̃fXNgbvṕAWindowŝV-SyncōŝŁAԂĒxȂȂ悤OotakeV-Syncɍ\킸Aɕ`ς܂Bv2.02
	//  Vistap̃CugDwmIsCompositionEnabled()֐ŁAV-SyncLȏԂ𒲂ׂ邪Aꂾ̂߂ɃCuKv
	//  ̖̂ʌȂ̂ŁÁA"Aero""VistaX^_[h"̃fXNgbvgĂԂz肵ăftHgƂB
	if ((APP_GetWindowsVista())&&(APP_GetVistaUseAutoVSync()))
	{
		//WaitOɕ`揈ς܂B
		if (bDraw)
		{
			//`揈
			hr = _pD3DDev->Present(NULL, NULL, NULL, NULL); //Direct3D́ASwapEffectVSync҂̂ɐݒ肷ƁAPresentsɎVSync҂ĂBVSyncƏdƂ̂Ō͎蓮ő҂B
			if (hr == D3DERR_DEVICELOST)
			{
				d3dDevReset();
				_pD3DDev->Present(NULL, NULL, NULL, NULL);
			}
			bDraw = FALSE; //`揈
		}
	}

	if (_bSyncTo60HzScreen)
	{
		t = timeGetTime() - _LastTimeSyncTime;
		if (t <= 16) //17ms(1/60s=16.7ms)ȏo߂Ăꍇ͑҂ȂB(timeGetTime()̌덷̂t=17ł܂16.1mso߂̂Ƃ邪x҂ȂƂDj
		{
			//̃Av̂߂ɏx݁BVBlank҂[vCPUL100%ɂȂ̂ŁAƏȓd́B
			t = 16 - t - 11; //-11͏Ȃ߂̃}[WB-11OKB-10قOKB-9ȉƃe|̗h炬킸ɉUCB16=PR}̎Ԗ16msB
							 //-11ƁAقǑPCłȂƈӖȂASleep()͂ǂĂ傫Ȍ덷oƂ悤Ȃ̂ŁA̐ݒŁB
			if ((t >= 1)&&(t <= 16-11)) //^C}[JE^̃I[o[t[lāA͈̔͂̂ƂSleepȂB
				Sleep(t);
			//҂BGetRasterStatus\bhŐB
			//		EBhEŏĂ鎞͂ȂPresentɂVSyncȂ(ɂ邩ȂDirect3D9̎dlۂ)̂ŁA蓮VSyncsB
			rs.InVBlank = FALSE;
			while (TRUE)
			{
				_pD3DDev->GetRasterStatus(0, &rs);
				if (rs.InVBlank)
					break; //VBlankԂɓ烋[v𔲂oB
				t = timeGetTime() - _LastTimeSyncTime;
				if ((t >= 18)||(t < 0)) //17.1msȏo߂ĂBorJE^I[o[t[
					break;
			}
		}
		_LastTimeSyncTime = timeGetTime(); //OSyncI^CƂċL^Ă
		if (bDraw)
		{
			//`揈
			hr = _pD3DDev->Present(NULL, NULL, NULL, NULL); //Direct3D́ASwapEffectVSync҂̂ɐݒ肷ƁAPresentsɎVSync҂ĂBVSyncƏdƂ̂Ō͎蓮ő҂B
			if (hr == D3DERR_DEVICELOST)
			{
				d3dDevReset();
				_pD3DDev->Present(NULL, NULL, NULL, NULL);
			}
		}
		return TRUE;
	}
	else //_bSyncTo60HzScreen  FALSȄꍇ
	{
		t = timeGetTime() - _LastTimeSyncTime;
		if (t <= 16) //17ms(1/60s=16.7ms)ȏo߂Ăꍇ͑҂ȂB(timeGetTime()̌덷̂t=17ł܂16.1mso߂̂Ƃ邪x҂ȂƂDj
		{
			//҂
			t = 16 - t; //16=PR}̎Ԗ16msB
			if (_SyncAjust == 0)
				t--; //Sleep̌덷ŏC(ɃmCY)ɂȂȂ߂̃}[WB
			if ((t >= 1)&&(t <= 16)) //^C}[JE^̃I[o[t[lāA͈̔͂̂ƂSleepȂB
				Sleep(t);
			if (++_SyncAjust == 3)
				_SyncAjust = 0; //3t[1񂾂SleepZ߂ɂB60fpsɋ߂ÂB
		}
		_LastTimeSyncTime = timeGetTime(); //OSyncI^CƂċL^Ă
		if (bDraw)
		{
			//`揈
			hr = _pD3DDev->Present(NULL, NULL, NULL, NULL); //PresentĂVSync҂`悾ݒɂȂĂ̂ŁA҂ɕ`悳B
			if (hr == D3DERR_DEVICELOST)
			{
				d3dDevReset();
				_pD3DDev->Present(NULL, NULL, NULL, NULL);
			}
		}
		return TRUE;
	}
}


void*
SCREEND3D_GetBuffer()
{
	return (void*)_pScreenPixels;
}


const Sint32
SCREEND3D_GetBufferPitch()
{
	return _SurfacePitch/2;
}


//C(Q[)ʗpItXN[bNāA(`)pAhXݒ肷B
static BOOL
lock_offscreen_surface(
	LONG*				pPitch,
	Uint16**			ppPixels)
{
	D3DLOCKED_RECT	pLockedRect;
	HRESULT			hr;

	hr = _pD3DSGame->LockRect(&pLockedRect, NULL, 0);
	if (hr == D3D_OK)
	{
		*ppPixels = (Uint16*)pLockedRect.pBits;
		*pPitch = pLockedRect.Pitch;
		return TRUE;
	}
	else
		return FALSE;
}


//C(Q[)ʗpItXN[NA܂B
//Ap[^̐ݒ͔f܂Bx,y0ŒB\[X𑜓x̓ItXN[ŜɌŒBcolor0tBŒB
void
SCREEND3D_FillRect(
	Sint32		x,
	Sint32		y,
	Sint32		width,
	Sint32		height,
	Uint32		color)
{
	LONG		pitch;
	LONG		pitchHalf;
	Uint16*		pPixels;
	Uint16*		pPixels0;
	int			i,j;

	if (lock_offscreen_surface(&pitch, &pPixels))
	{
		pitchHalf = pitch / 2;
		pPixels0 = pPixels;
		for (i = 0; i < _Height; i++)
		{
			pPixels = pPixels0;
			for (j = 0; j < _Width; j++)
			{
				*pPixels++ = 0x00;
				*pPixels++ = 0x00; //4byteԂ(Phbg)܂B
			}
			pPixels0 += pitchHalf;
		}
		_pD3DSGame->UnlockRect();
	}
}


//ʑŜNA܂B
void
SCREEND3D_Clear()
{
	HRESULT		hr;

	_pD3DDev->Clear(0, NULL, D3DCLEAR_TARGET, D3DCOLOR_XRGB(0,0,0), 1.0, 0);
	hr = _pD3DDev->Present(NULL, NULL, NULL, NULL); //PresentsȂƔfȂB
	if (hr == D3DERR_DEVICELOST)
	{
		d3dDevReset();
		_pD3DDev->Present(NULL, NULL, NULL, NULL);
	}
}


//eLXgbZ[Wݒ肵܂B
void
SCREEND3D_SetMessageText(
	char*	pText)
{
	_pMessageText = pText;
}


//eLXgbZ[W̕\
static void
print_message()
{
	HDC			dc;
	HFONT		prevFont;
	HFONT		hFont;
	LOGFONT		logFont;
	RECT		rcSrc;
	RECT		rcDst;
	RECT		rc;
	int			a,fs;

	if (!APP_GetInit())
		return; //ŏ̏SĊĂȂꍇ́A\sȂBCD-ROMQ[W[ƂɃbZ[W̂Bv1.67

	//foCXReLXg擾
	if (_pD3DSText->GetDC(&dc) != D3D_OK)
		return;

	//tHgTCY
	switch (_Magnification)
	{
		case 1: fs = 12; break;
		case 2:	fs = 16; break;
		case 3: fs = 13; break;
		default: //4
			fs = 15; break;
	}
	hFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
	GetObject(hFont, sizeof(LOGFONT), &logFont);
	logFont.lfHeight = fs;
	logFont.lfWidth = 0;
	hFont = CreateFontIndirect(&logFont);
	prevFont = (HFONT)SelectObject(dc, hFont);
	//obt@ɕ`
	rc.left		= 0;
	rc.right	= 0;
	rc.top		= 0;
	rc.bottom	=fs;
	SetBkColor(dc, RGB(48,96,48));
	SetTextColor(dc, RGB(255,255,255));
	DrawText(dc, _pMessageText, lstrlen(_pMessageText), &rc,
			 DT_CALCRECT | DT_SINGLELINE | DT_NOPREFIX); //\V~[VBrcɕ\Ƃ̃TCYB
	DrawText(dc, _pMessageText, lstrlen(_pMessageText), &rc, DT_SINGLELINE | DT_NOPREFIX); //\
	
	SelectObject(dc, prevFont);
	DeleteObject(hFont);
	_pD3DSText->ReleaseDC(dc);
	
	//]ʒuTCY̒
	rcSrc.left	= 0;
	rcSrc.top	= 0;
	rcSrc.right	= rc.right;
	rcSrc.bottom= fs;
	//]ʒu̒\͈̔͂₷邽߂Ɋg傷B
	if ((APP_GetOverscanHideBlackLR())&&(MAINBOARD_GetShowOverscanLeft() == 0)) //ẼI[o[XL̈ɍтtȂ
		rcDst.left = _GameLeft; //т̂ŃMM܂ōɊ񂹂ĂhOKB
	else //ʏ
		rcDst.left = _GameLeft + 3;
	if ((APP_GetOverscanHideBlackTop())&&(MAINBOARD_GetShowOverscanTop() < 8)) //㑤̃I[o[XL̈ɍтtȂ
	{
		rcDst.top = _GameTop; //т̂ŃMM܂ŏɊ񂹂ĂhOKB
		a = (8-MAINBOARD_GetShowOverscanTop())*_Magnification;
		if (a < 4) //ѕ4hbgȂ
			rcDst.top += (4-a);
	}
	else //ʏ
		rcDst.top = _GameTop + 4;
	if (_Magnification >= 3)
	{
		rcDst.right	= rcDst.left + rcSrc.right * 2; //Q{g
		rcDst.bottom = rcDst.top + fs * 2; //cQ{g
	}
	else
	{
		rcDst.right	= rcDst.left + rcSrc.right;
		rcDst.bottom = rcDst.top + fs;
	}
	if (rcDst.right > _GameRight) //bZ[WĂ͂ݏoĂ܂ꍇ
	{
		rcSrc.right = (LONG)((double)rcSrc.right / ((double)rcDst.right / (double)_GameRight)); //\[X
		rcDst.right = _GameRight;
	}
	//]
	_pD3DDev->StretchRect(_pD3DSText, &rcSrc, _pD3DSBack, &rcDst, D3DTEXF_NONE); //̓NbL邽NONEgB
}


//FPS̕\
static void
print_fps()
{
	HDC			dc;
	HFONT		prevFont;
	HFONT		hFont;
	LOGFONT		logFont;
	RECT		rcSrc;
	RECT		rcDst;
	RECT		rc;
	int			fs;
	char		text[3+1]; //ꉞR܂ŗp
	int			a;

	//foCXReLXg擾
	if (_pD3DSFps->GetDC(&dc) != D3D_OK)
		return;

	//tHgTCY
	switch (_Magnification)
	{
		case 1: fs = 12; break;
		case 2:	fs = 16; break;
		case 3: fs = 13; break;
		default: //4
			fs = 15; break;
	}
	hFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
	GetObject(hFont, sizeof(LOGFONT), &logFont);
	logFont.lfHeight = fs;
	logFont.lfWidth = 0;
	hFont = CreateFontIndirect(&logFont);
	prevFont = (HFONT)SelectObject(dc, hFont);
	//obt@ɕ`
	rc.left		= 0;
	rc.right	= 0;
	rc.top		= 0;
	rc.bottom	=fs;
	SetBkColor(dc, RGB(48,96,48));
	SetTextColor(dc, RGB(255,255,255));
	a = MAINBOARD_GetDisplayedFrames();
	if (a > 999) a = 999;
	sprintf(text, "%d", a);
	DrawText(dc, text, lstrlen(text), &rc,
			 DT_CALCRECT | DT_SINGLELINE | DT_NOPREFIX); //\V~[VBrcɕ\Ƃ̃TCYB
	DrawText(dc, text, lstrlen(text), &rc, DT_SINGLELINE | DT_NOPREFIX); //\

	SelectObject(dc, prevFont);
	DeleteObject(hFont);
	_pD3DSFps->ReleaseDC(dc);
	
	//]ʒuTCY̒
	rcSrc.left	= 0;
	rcSrc.top	= 0;
	rcSrc.right	= rc.right;
	rcSrc.bottom= fs;
	//]ʒu̒\͈̔͂₷邽߂Ɋg傷B
	if ((APP_GetOverscanHideBlackLR())&&(MAINBOARD_GetShowOverscanLeft() == 0)) //ẼI[o[XL̈ɍтtȂ
		rcDst.left = _GameLeft; //т̂ŃMM܂ōɊ񂹂ĂhOKB
	else //ʏ
		rcDst.left = _GameLeft + 3;
	if ((APP_GetOverscanHideBlackBottom())&&(MAINBOARD_GetShowOverscanBottom() < 8)) //̃I[o[XL̈ɍтtȂ
	{
		rcDst.bottom = _GameBottom; //т̂ŃMM܂ŉɊ񂹂ĂhOKB
		a = (8-MAINBOARD_GetShowOverscanBottom())*_Magnification;
		if (a < 3) //ѕ3hbgȂ
			rcDst.bottom -= (3-a);
	}
	else //ʏ
		rcDst.bottom = _GameBottom - 3; //ɕ\
	if (_Magnification >= 3)
	{
		rcDst.right	= rcDst.left + rcSrc.right * 2; //Q{g
	    rcDst.top = rcDst.bottom - fs * 2; //cQ{g
	}
	else
	{
		rcDst.right	= rcDst.left + rcSrc.right;
	    rcDst.top = rcDst.bottom - fs;
	}
	//]
	_pD3DDev->StretchRect(_pD3DSFps, &rcSrc, _pD3DSBack, &rcDst, D3DTEXF_NONE); //̓NbL邽NONEgB
}


//`pobNT[tFX֓]鏈ȂǁB
static void
zoom_d3dTensou(
	Uint16*		pTvW,	//]̉sNZB[0]`[255]16+224+16(Overscan)CԂBɂ͕\Jn(.I[o[XL\Ȃꍇ[16]ɂȂ)̃AhXB
	Sint32		h,		//]̏csNZBʏ224B㉺̃I[o[XLꍇ̂Ԃ񑝂₵ĂĂԁB
	Sint32		executeCode)
{
	RECT		rcSrc;
	RECT		rcDst;
	RECT		rc;
	Sint32		a,b,c,d,s,i,w2,h2;
	BOOL		bRasterChange = FALSE; //X^ƂɈقȂ𑜓xݒ肳ĂꍇTRUE
	Uint16*		pTvW2 = pTvW;
	Sint32		ot = 16-MAINBOARD_GetShowOverscanTop(); //]̊JnYW
	Sint32		wMag; //̃\[X{
	Sint32		hMag; //c̃\[X{

	//]̉ 
	s = (*pTvW2);
	for (i=0; i<h; i++)
	{
		if ((*pTvW2) != s)
		{
			bRasterChange = TRUE;
			if ((*pTvW) < s)
				s = (*pTvW); //s=ԏBtXgb`ɂ݂oȂ悤ɁB
		}
		*pTvW2++;
	}

	//]̈ʒu 
	if (_Flags & SCREEN_FFULLSCREEN)
	{
		if (APP_GetFullStretched())
		{
			//AXyNg4:3ɕۂ
			if (_Width/4 >= _Height/3)
			{	//ĉقẐŏcƂ
				w2 = (Sint32)((double)(_Height / 3.0 * 4.0 + 0.5));
				a = (_Width - w2) / 2;
				if ((MAINBOARD_GetShowOverscanLeft() > 0)&&(executeCode != 3)) //ẼI[o[XL̈\Ȃ
					b = (_Height - (Sint32)((double)_Height * 0.96137 + 0.5)) / 2; //0.96137=224/((268-256)/4*3+224)
				else
					b = 0;
				c = _Width - a;
				d = _Height - b;
			}
			else
			{	//̂قẐŉƂ
				h2 = (Sint32)((double)(_Width / 4.0 * 3.0 + 0.5));
				a = 0;
				if ((MAINBOARD_GetShowOverscanLeft() > 0)&&(executeCode != 3)) //ẼI[o[XL̈\Ȃ
					b = (_Height - (Sint32)((double)h2 * 0.96137 + 0.5)) / 2; //0.96137=224/((268-256)/4*3+224)
				else
					b = (_Height - h2) / 2;
				c = _Width;
				d = _Height - b;
			}
			//tXgb`͏㉺̃I[o[XL̈\łȂ߁A㉺̃I[o[XL̈JbgB
			h -= MAINBOARD_GetShowOverscanTop() + MAINBOARD_GetShowOverscanBottom();
			ot = 16;
			bRasterChange = FALSE; //tXgb`̓X^Ƃ̉𑜓xύXłȂB
		}
		else if (APP_GetStretched())
		{
			if ((MAINBOARD_GetShowOverscanLeft() > 0)&&(executeCode != 3)) //ẼI[o[XL̈\Ȃ
				w2 = (Sint32)(313.24 * (double)_Magnification + 0.5);
			else
				w2 = 299 * _Magnification; //AXyNgŒ̂߉299(2{598)̕\͈́B
			if (APP_GetVStretched()) //cʃ[hȂ
				w2 = (Sint32)((double)w2 * (256.0/336.0)); //@l256:336̔ŏki256ȊÕQ[lɉ\j
			//AXyNgTVʂƓ4:3ɁBc̒PCEW224̐{(Q{)ɂ
			a = (_Width - w2) / 2;
			b = (_Height - 224*_Magnification) / 2;
			c = a + w2;
			d = b + 224*_Magnification;
			if (MAINBOARD_GetShowOverscanTop() > 0) //㑤̃I[o[XL̈\Ȃ
			{
				b -= MAINBOARD_GetShowOverscanTop() * _Magnification;
				if (b < 0) //ʂ͂ݏoĂ܂ꍇB1440x900,1600x900Ȃǂł蓾B
				{	//AXyNgۂ߁AI[o[XLJbgB
					b = (_Height - 224*_Magnification) / 2;
					h -= MAINBOARD_GetShowOverscanTop();
					ot = 16;
				}
			}
			if (MAINBOARD_GetShowOverscanBottom() > 0) //̃I[o[XL̈\Ȃ
			{
				d += MAINBOARD_GetShowOverscanBottom() * _Magnification;
				if (d > _Height) //ʂ͂ݏoĂ܂ꍇB1440x900,1600x900Ȃǂł蓾B
				{	//AXyNgۂ߁AI[o[XLJbgB
					d = b + 224*_Magnification;
					h -= MAINBOARD_GetShowOverscanBottom();
				}
			}
		}
		else //Xgb`Ȃꍇ
		{
			w2 = (*pTvW)*_Magnification;
			if (w2 > _Width) w2 = _Width; //ʂ͂ݏoĂ܂ꍇ́AXgb`(k)đΉB
			a = (_Width - w2) / 2;
			b = (_Height - 224*_Magnification) / 2;
			c = a + w2;
			d = b + 224*_Magnification;
			if (MAINBOARD_GetShowOverscanTop() > 0) //㑤̃I[o[XL̈\Ȃ
			{
				b -= MAINBOARD_GetShowOverscanTop() * _Magnification;
				if (b < 0) b = 0; //ʂ͂ݏoĂ܂ꍇ́AXgb`(k)đΉB1440x900,1600x900Ȃǂł蓾B
			}
			if (MAINBOARD_GetShowOverscanBottom() > 0) //̃I[o[XL̈\Ȃ
			{
				d += MAINBOARD_GetShowOverscanBottom() * _Magnification;
				if (d > _Height) d = _Height; //ʂ͂ݏoĂ܂ꍇ́AXgb`(k)đΉB1440x900,1600x900Ȃǂł蓾B
			}
		}
	}
	else //EBhE[ĥƂ
	{
		//Direct3DStretchRectłWindoẅʒug̑ԂȂǂKvȂB(0,0)`̍ɂȂB
		GetWindowRect(_hWnd, &rc);
		a = 0;
		b = 0;
		if (APP_GetOverscanHideBlackTop()) //㑤̃I[o[XL̈ɍтĉBݒȂ
			b += (8 - MAINBOARD_GetShowOverscanTop()) * _Magnification;
		c = APP_GetGameWidth(_Magnification);
		d = b + (MAINBOARD_GetShowOverscanTop() + 224 + MAINBOARD_GetShowOverscanBottom()) * _Magnification;
		if (((MAINBOARD_GetShowOverscanLeft() > 0)&&((*(pTvW+MAINBOARD_GetShowOverscanTop()+223)) == 512))|| //512̂Ƃ̓I[o[XL\Ȃ
			((MAINBOARD_GetShowOverscanLeft() == 0)&&(APP_GetOverscanHideBlackLR()))||
			(executeCode == 3))
		{	//Eɍтzu
			if (APP_GetVStretched()) //cʃ[hȂ
			{
				a += (Sint32)(5.34 * (double)_Magnification + 0.5);		//5.34=299/256*(256/336)*6dot
				c -= (Sint32)(5.34 * (double)_Magnification + 0.5);
			}
			else if (APP_GetStretched())
			{
				a += (Sint32)(7.01 * (double)_Magnification + 0.5);		//7.01=299/256*6dot
				c -= (Sint32)(7.01 * (double)_Magnification + 0.5);
			}
		}
	}

	if (IsIconic(WINMAIN_GetHwnd())) //EBhEŏĂ鎞BhesŏĒƂȂǂɏyB
		if (executeCode != 2) //XN[Vbgp֓]ȊȌꍇ
		{
			//AԂ҂
			SCREEND3D_WaitVBlank(FALSE); //`揈͍sȂ
			return;
		}

	//`𑜓x̕ύXꍇAS~cȂ悤ɉʑŜNAB
	if (MAINBOARD_GetResolutionChange())
		_pD3DDev->Clear(0, NULL, D3DCLEAR_TARGET, D3DCOLOR_XRGB(0,0,0), 1.0, 0);

	//\[X͈͂肵AfoCX̃obNT[tFX(DirectDrawł̃vC}T[tFXƓl)֓]B
	if (_Magnification >= 2) //x2ȏ̏ꍇ
	{
		if (APP_GetScanLineType() != 0)
		{
			if (APP_GetTvMode())
				wMag = 1;
			else
				wMag = 2; //x2ȏ͂Q{hbgŒBixAbv{g傳ꂽƂɃoCjAtB^ɂj
			hMag = _Magnification; //c͔{Ԃ̃\[Xpӂē]B
		}
		else
		{
			wMag = 2;
			if (_Magnification == 2)
				hMag = _Magnification; //c͔{Ԃ̃\[Xpӂē]B
			else
				hMag = _Magnification-1; //3x,4x̂Ƃ́Aꂼ2x,3xɊgBiWM[yxAbvj
		}
	}
	else //x1̏ꍇ
		wMag = hMag = 1;
	_GameLeft   = a; //print_message()ŕ\ʒû߂ɁAQ[ʓ]̍WTĂB
	_GameRight  = c; //
	_GameTop    = b; //
	_GameBottom = d; //
	if (!bRasterChange)
	{	//ʏ
		SetRect(&rcDst, a, b, c, d);
		if (executeCode == 5) //I[o[XL̈̍EJbgꍇ
			SetRect(&rcSrc, 6*wMag, ot*hMag, (s-6)*wMag, (ot+h)*hMag); //̂Ƃѕ̃\[X6hbgx{B
		else //ʏ
			SetRect(&rcSrc, 0, ot*hMag, s*wMag, (ot+h)*hMag);
		switch (APP_GetD3DEffect())
		{
			case 1: _pD3DDev->StretchRect(_pD3DSGame, &rcSrc, _pD3DSBack, &rcDst, D3DTEXF_POINT); //ԃhbgNbL
				break;
			case 2: _pD3DDev->StretchRect(_pD3DSGame, &rcSrc, _pD3DSBack, &rcDst, D3DTEXF_LINEAR); //傤ǂz
				break;
			default: //0
				_pD3DDev->StretchRect(_pD3DSGame, &rcSrc, _pD3DSBack, &rcDst, D3DTEXF_NONE); //ȂhbgNbL
				break;
		}
	}
	else
	{	//X^ƂɈقȂ𑜓xݒ肳ĂƂBv1.28XVBPC]悤ɂBv2.00XVBDirect3DȂVistałB
		for (i=0; i<h; i++)
		{
			if (((*pTvW) == 512)&&(MAINBOARD_GetShowOverscanLeft() > 0)) //512̂Ƃ̓I[o[XL\Ȃ
			{	//Eɍтzu
				if (APP_GetVStretched()) //cʃ[hȂ
					SetRect(&rcDst, a+(int)(5.34*(double)_Magnification+0.5), b+i*_Magnification,
									c-(int)(5.34*(double)_Magnification+0.5)-1, b+i*_Magnification+_Magnification);
				else if (APP_GetStretched())
					SetRect(&rcDst, a+(int)(7.01*(double)_Magnification+0.5), b+i*_Magnification,
									c-(int)(7.01*(double)_Magnification+0.5)-1, b+i*_Magnification+_Magnification);
				else
					SetRect(&rcDst, a, b+i*_Magnification, c, b+i*_Magnification+_Magnification);
			}
			else //ʏ
				SetRect(&rcDst, a, b+i*_Magnification, c, b+i*_Magnification+_Magnification);
			if (executeCode == 5) //I[o[XL̈̍EJbgꍇ
				SetRect(&rcSrc, 6*wMag, (ot+i)*hMag, ((*pTvW)-6)*wMag, (ot+i)*hMag+hMag);
			else //ʏ
				SetRect(&rcSrc, 0, (ot+i)*hMag, (*pTvW)*wMag, (ot+i)*hMag+hMag);
			switch (APP_GetD3DEffect())
			{
				case 1: _pD3DDev->StretchRect(_pD3DSGame, &rcSrc, _pD3DSBack, &rcDst, D3DTEXF_POINT); //ԃhbgNbL
					break;
				case 2: _pD3DDev->StretchRect(_pD3DSGame, &rcSrc, _pD3DSBack, &rcDst, D3DTEXF_LINEAR); //傤ǂz
					break;
				default: //0
					_pD3DDev->StretchRect(_pD3DSGame, &rcSrc, _pD3DSBack, &rcDst, D3DTEXF_NONE); //ȂhbgNbL
					break;
			}
			*pTvW++;
		}
	}

	if (executeCode == 2) return;//XN[Vbgp֓]̏ꍇŏI

	//eLXgbZ[W̕\BDirect3D9StretchRect̓v[T[tFXm̓{]oȂ̂ŁA
	//							DirectDraŵƂƈႢAeLXgbZ[WobNobt@[֒ړ]悤ɂB
	if (*_pMessageText != 0) //bZ[Wݒ肳Ă
		print_message();

	//FPS̕\Bv1.50ǉ
	if (APP_GetShowFPS())
		print_fps();

	//AԂ҂ۂ̕`揈
	SCREEND3D_WaitVBlank(TRUE);
}


//`BݏB
#define	GB	(d & 0x000000FF)
#define	GG	(d & 0x0000FF00)>>8
#define	GR	(d & 0x00FF0000)>>16
//zoom3x()Czoom2x()Czoom1x()pӁBxd̂߂ꂼʃ[`ɁBCƂɉ𑜓xςĂQ[ɑΉB
//32rbgJ[xS{p
static void
zoom4x_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		srcY,			// ]YW
	Uint16*		pTvW,			// eC̕
	Sint32		srcH)			// ]̍
{
	int			i,j;
	Uint32*		pSrc0;
	Uint16*		pDst;
	Uint16*		pDst0;
	Uint32		d;

	// XLC80%
	pSrc0 = pSrc;
	pDst0 = _pPixels + srcY*(_Pitch << 1);
	for (i = 0; i < srcH; i++)
	{
		pSrc = pSrc0;
		pDst = pDst0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_Gamma[GG] << 8)| _Gamma[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_Gamma[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_GammaS90[GG] << 8)| _GammaS90[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS90[GR]); //2byteԂ(hbg)܂BQ{g(90%cXLC)
		}
		*pDst++ = 0;  *pDst = 0; //Direct3Dł͉E[ɂPhbgԂNA()}[WĂȂƉE[B
		pDst = pDst0 + _PitchHalf;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++) //Qڂ95%XLC
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS95[GG] << 8)| _GammaS95[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS95[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_GammaS90[GG] << 8)| _GammaS90[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS90[GR]); //2byteԂ(hbg)܂BQ{g(90%cXLC)
		}
		*pDst++ = 0;  *pDst = 0;
		pDst = pDst0 + _Pitch;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++) //Rڂ85%XLC
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS85[GG] << 8)| _GammaS85[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS85[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_GammaS85[GG] << 8)| _GammaS85[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS85[GR]); //2byteԂ(hbg)܂BQ{g(90%cXLC)
		}
		*pDst++ = 0;  *pDst = 0;
		pDst = pDst0 + _Pitch + _PitchHalf;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS80[GG] << 8)| _GammaS80[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS80[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_GammaS80[GG] << 8)| _GammaS80[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS80[GR]); //2byteԂ(hbg)܂BQ{g(80%cXLC)
		}
		*pDst++ = 0;  *pDst = 0;
		pDst0 += (_Pitch << 1);
		pSrc0 += SOURCE_PITCH;
		*pTvW++;
	}
}

//32rbgJ[xR{p
static void
zoom3x_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		srcY,			// ]YW
	Uint16*		pTvW,			// eC̕
	Sint32		srcH)			// ]̍
{
	int			i,j;
	Uint32*		pSrc0;
	Uint16*		pDst;
	Uint16*		pDst0;
	Uint32		d;

	// XLC80%
	pSrc0 = pSrc;
	pDst0 = _pPixels + srcY*(_PitchHalf + _Pitch);
	for (i = 0; i < srcH; i++)
	{
		pSrc = pSrc0;
		pDst = pDst0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_Gamma[GG] << 8)| _Gamma[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_Gamma[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_GammaS90[GG] << 8)| _GammaS90[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS90[GR]); //2byteԂ(hbg)܂BQ{g(90%cXLC)
		}
		*pDst++ = 0;  *pDst = 0; //Direct3Dł͉E[ɂPhbgԂNA()}[WĂȂƉE[B
		pDst = pDst0 + _PitchHalf;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++) //Qڂ90%XLCɂB
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS90[GG] << 8)| _GammaS90[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS90[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_GammaS90[GG] << 8)| _GammaS90[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS90[GR]); //2byteԂ(hbg)܂BQ{g(90%cXLC)
		}
		*pDst++ = 0;  *pDst = 0;
		pDst = pDst0 + _Pitch;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS80[GG] << 8)| _GammaS80[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS80[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_GammaS80[GG] << 8)| _GammaS80[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS80[GR]); //2byteԂ(hbg)܂BQ{g
		}
		*pDst++ = 0;  *pDst = 0;
		pDst0 += _PitchHalf + _Pitch;
		pSrc0 += SOURCE_PITCH;
		*pTvW++;
	}
}

//32rbgJ[xQ{pB
static void
zoom2x_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		srcY,			// ]YW
	Uint16*		pTvW,			// eC̕
	Sint32		srcH)			// ]̍
{
	int			i,j;
	Uint32*		pSrc0;
	Uint16*		pDst;
	Uint16*		pDst0;
	Uint32		d;

	// XLC80%
	pSrc0 = pSrc;
	pDst0 = _pPixels + srcY*_Pitch;
	for (i = 0; i < srcH; i++)
	{
		pSrc = pSrc0;
		pDst = pDst0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_Gamma[GG] << 8)| _Gamma[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_Gamma[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_GammaS90[GG] << 8)| _GammaS90[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS90[GR]); //2byteԂ(hbg)܂BQ{g(90%cXLC)
		}
		*pDst++ = 0;  *pDst = 0; //Direct3Dł͉E[ɂPhbgԂNA()}[WĂȂƉE[B
		pDst = pDst0 + _PitchHalf;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS80[GG] << 8)| _GammaS80[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS80[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_GammaS80[GG] << 8)| _GammaS80[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS80[GR]); //2byteԂ(hbg)܂BQ{g(80%cXLC)
		}
		*pDst++ = 0;  *pDst = 0;
		pDst0 += _Pitch;
		pSrc0 += SOURCE_PITCH;
		*pTvW++;
	}
}

//XLC32rbgJ[xS{p
static void
zoom4xHS_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		srcY,			// ]YW
	Uint16*		pTvW,			// eC̕
	Sint32		srcH)			// ]̍
{
	int			i,j;
	Uint32*		pSrc0;
	Uint16*		pDst;
	Uint16*		pDst0;
	Uint32		d;

	// XLC80%
	pSrc0 = pSrc;
	pDst0 = _pPixels + srcY*(_Pitch << 1);
	for (i = 0; i < srcH; i++)
	{
		pSrc = pSrc0;
		pDst = pDst0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_Gamma[GG] << 8)| _Gamma[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_Gamma[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_Gamma[GG] << 8)| _Gamma[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_Gamma[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0; //Direct3Dł͉E[ɂPhbgԂNA()}[WĂȂƉE[B
		pDst = pDst0 + _PitchHalf;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++) //Qڂ95%XLC
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS95[GG] << 8)| _GammaS95[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS95[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_GammaS95[GG] << 8)| _GammaS95[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS95[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0;
		pDst = pDst0 + _Pitch;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++) //Rڂ85%XLC
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS85[GG] << 8)| _GammaS85[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS85[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_GammaS85[GG] << 8)| _GammaS85[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS85[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0;
		pDst = pDst0 + _Pitch + _PitchHalf;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS80[GG] << 8)| _GammaS80[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS80[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_GammaS80[GG] << 8)| _GammaS80[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS80[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0;
		pDst0 += (_Pitch << 1);
		pSrc0 += SOURCE_PITCH;
		*pTvW++;
	}
}

//XLC32rbgJ[xR{p
static void
zoom3xHS_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		srcY,			// ]YW
	Uint16*		pTvW,			// eC̕
	Sint32		srcH)			// ]̍
{
	int			i,j;
	Uint32*		pSrc0;
	Uint16*		pDst;
	Uint16*		pDst0;
	Uint32		d;

	// XLC80%
	pSrc0 = pSrc;
	pDst0 = _pPixels + srcY*(_PitchHalf + _Pitch);
	for (i = 0; i < srcH; i++)
	{
		pSrc = pSrc0;
		pDst = pDst0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_Gamma[GG] << 8)| _Gamma[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_Gamma[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_Gamma[GG] << 8)| _Gamma[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_Gamma[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0; //Direct3Dł͉E[ɂPhbgԂNA()}[WĂȂƉE[B
		pDst = pDst0 + _PitchHalf;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++) //Qڂ90%XLCɂB
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS90[GG] << 8)| _GammaS90[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS90[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_GammaS90[GG] << 8)| _GammaS90[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS90[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0;
		pDst = pDst0 + _Pitch;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS80[GG] << 8)| _GammaS80[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS80[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_GammaS80[GG] << 8)| _GammaS80[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS80[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0;
		pDst0 += _PitchHalf + _Pitch;
		pSrc0 += SOURCE_PITCH;
		*pTvW++;
	}
}

//XLC32rbgJ[xQ{pB
static void
zoom2xHS_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		srcY,			// ]YW
	Uint16*		pTvW,			// eC̕
	Sint32		srcH)			// ]̍
{
	int			i,j;
	Uint32*		pSrc0;
	Uint16*		pDst;
	Uint16*		pDst0;
	Uint32		d;

	// XLC80%
	pSrc0 = pSrc;
	pDst0 = _pPixels + srcY*_Pitch;
	for (i = 0; i < srcH; i++)
	{
		pSrc = pSrc0;
		pDst = pDst0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_Gamma[GG] << 8)| _Gamma[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_Gamma[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_Gamma[GG] << 8)| _Gamma[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_Gamma[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0; //Direct3Dł͉E[ɂPhbgԂNA()}[WĂȂƉE[B
		pDst = pDst0 + _PitchHalf;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS80[GG] << 8)| _GammaS80[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS80[GR]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)((_GammaS80[GG] << 8)| _GammaS80[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS80[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0;
		pDst0 += _Pitch;
		pSrc0 += SOURCE_PITCH;
		*pTvW++;
	}
}

//mXLCłQ{R{S{pB32rbgJ[B
static void
zoom2x3x4xNS_dd32(
	int			bairitsu,		// 2x3x4xB2xȂ2B3xȂ3B4xȂ4B
	Uint32*		pSrc,			// ]̃|C^
	Sint32		srcY,			// ]YW
	Uint16*		pTvW,			// eC̕
	Sint32		srcH)			// ]̍
{
	int			i,j,k;
	Uint32*		pSrc0;
	Uint16*		pDst;
	Uint16*		pDst0;
	Uint32		d;
	int			bairitsu2; //c̃hbg{ɃfW^g傷邩Bx2x3Ȃ2Bx4Ȃ3B

	if (bairitsu == 2)
		bairitsu2 = 2;
	else
		bairitsu2 = bairitsu -1;

	// XLCȂ
	pSrc0 = pSrc;
	pDst0 = _pPixels + srcY*(_PitchHalf*bairitsu2);
	for (i = 0; i < srcH; i++)
	{
		for (k = 1; k <= bairitsu2; k++) //cbairitsu{ɃfW^g傷
		{
			pSrc = pSrc0;
			pDst = pDst0;
			for (j = 0; j < *pTvW; j++)
			{
				d = *pSrc++;
				*pDst++ = (Uint16)((_Gamma[GG] << 8)| _Gamma[GB]); //2byteԂ(hbg)܂B
				*pDst++ = (Uint16)(_Gamma[GR]); //2byteԂ(hbg)܂B
				*pDst++ = (Uint16)((_Gamma[GG] << 8)| _Gamma[GB]); //2byteԂ(hbg)܂B
				*pDst++ = (Uint16)(_Gamma[GR]); //2byteԂ(hbg)܂BQ{g(XLCȂ)
			}
			*pDst++ = 0;  *pDst = 0; //Direct3Dł͉E[ɂPhbgԂNA()}[WĂȂƉE[B
			pDst0 += _PitchHalf;
		}
		pSrc0 += SOURCE_PITCH;
		*pTvW++;
	}
}

//32rbgJ[xP{pBXLCȂB
static void
zoom1xNS_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		srcY,			// ]YW
	Uint16*		pTvW, 			//
	Sint32		srcH)			// ]̍
{
	int			i,j;
	Uint32*		pSrc0;
	Uint16*		pDst;
	Uint16*		pDst0;
	Uint32		d;

	// P{Ȃ̂ŃXLC͖
	pSrc0 = pSrc;
	pDst0 = _pPixels + srcY*_PitchHalf;
	for (i = 0; i < srcH; i++)
	{
		pSrc = pSrc0;
		pDst = pDst0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_Gamma[GG] << 8)| _Gamma[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_Gamma[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0; //Direct3Dł͉E[ɂPhbgԂNA()}[WĂȂƉE[B
		pDst0 += _PitchHalf;
		pSrc0 += SOURCE_PITCH;
		*pTvW++;
	}

}

//TV Mode 32rbgJ[S{pB
static void
zoom4xTV_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		srcY,			// ]YW
	Uint16*		pTvW,			// eC̕
	Sint32		srcH)			// ]̍
{
	int			i,j;
	Uint32*		pSrc0;
	Uint16*		pDst;
	Uint16*		pDst0;
	Uint32		d;

	// XLC80%
	pSrc0 = pSrc;
	pDst0 = _pPixels + srcY*(_Pitch << 1);
	for (i = 0; i < srcH; i++)
	{
		pSrc = pSrc0;
		pDst = pDst0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_Gamma[GG] << 8)| _Gamma[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_Gamma[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0; //Direct3Dł͉E[ɂPhbgԂNA()}[WĂȂƉE[B
		pDst = pDst0 + _PitchHalf;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++) //Qڂ95%XLC
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS95[GG] << 8)| _GammaS95[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS95[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0;
		pDst = pDst0 + _Pitch;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++) //Rڂ85%XLC
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS85[GG] << 8)| _GammaS85[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS85[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0;
		pDst = pDst0 + _Pitch + _PitchHalf;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS80[GG] << 8)| _GammaS80[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS80[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0;
		pDst0 += (_Pitch << 1);
		pSrc0 += SOURCE_PITCH;
		*pTvW++;
	}
}

//TV Mode 32rbgJ[R{pB
static void
zoom3xTV_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		srcY,			// ]YW
	Uint16*		pTvW,			// eC̕
	Sint32		srcH)			// ]̍
{
	int			i,j;
	Uint32*		pSrc0;
	Uint16*		pDst;
	Uint16*		pDst0;
	Uint32		d;

	// XLC80%
	pSrc0 = pSrc;
	pDst0 = _pPixels + srcY*(_PitchHalf + _Pitch);
	for (i = 0; i < srcH; i++)
	{
		pSrc = pSrc0;
		pDst = pDst0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_Gamma[GG] << 8)| _Gamma[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_Gamma[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0; //Direct3Dł͉E[ɂPhbgԂNA()}[WĂȂƉE[B
		pDst = pDst0 + _PitchHalf;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++) //Qڂ90%XLCɂB
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS90[GG] << 8)| _GammaS90[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS90[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0;
		pDst = pDst0 + _Pitch;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS80[GG] << 8)| _GammaS80[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS80[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0;
		pDst0 += _PitchHalf + _Pitch;
		pSrc0 += SOURCE_PITCH;
		*pTvW++;
	}
}

//TV Mode 32rbgJ[ Q{pB
static void
zoom2xTV_dd32(
	Uint32*		pSrc,			// ]̃|C^
	Sint32		srcY,			// ]YW
	Uint16*		pTvW,			// eC̕
	Sint32		srcH)			// ]̍
{
	int			i,j;
	Uint32*		pSrc0;
	Uint16*		pDst;
	Uint16*		pDst0;
	Uint32		d;

	// XLC80%
	pSrc0 = pSrc;
	pDst0 = _pPixels + srcY*_Pitch;
	for (i = 0; i < srcH; i++)
	{
		pSrc = pSrc0;
		pDst = pDst0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_Gamma[GG] << 8)| _Gamma[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_Gamma[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0; //Direct3Dł͉E[ɂPhbgԂNA()}[WĂȂƉE[B
		pDst = pDst0 + _PitchHalf;
		pSrc = pSrc0;
		for (j = 0; j < *pTvW; j++)
		{
			d = *pSrc++;
			*pDst++ = (Uint16)((_GammaS80[GG] << 8)| _GammaS80[GB]); //2byteԂ(hbg)܂B
			*pDst++ = (Uint16)(_GammaS80[GR]); //2byteԂ(hbg)܂B
		}
		*pDst++ = 0;  *pDst = 0;
		pDst0 += _Pitch;
		pSrc0 += SOURCE_PITCH;
		*pTvW++;
	}
}
#undef GR
#undef GG
#undef GB


//pSrc̕`f[^p\R\ɃGR[hAobNobt@։摜݂܂B
//		CƂɉ𑜓xςĂQ[iՂ̌C120%ȂǁjɂΉB
void
SCREEND3D_Blt(
	const void*		pSrc,
	Sint32			srcX,
	Sint32			srcY,
	Uint16*			pTvW,	//]̉sNZBsrcHC̐Ԃ
	Sint32			srcH,
	Sint32			executeCode)  //KitaoǉBsR[hB0cGR[hsB1cvC}ʂ֓]sB2cXN[Vbgpʂ֓]sB
								  //					   3cEɍ(I[o[XL)zuĂ̓](Ƃ1Ɠ)
								  //					   5cẼI[o[XLJbgĂ̓](Ƃ1Ɠ)
{
	Uint32*		pSrc32;
	Sint32		scanLineType;

	if ((pSrc==NULL)||(srcH<=0))
		return;

	//v1.28XVBCr̃GR[hɑΉB
	pSrc32 = (Uint32*)pSrc + srcY * 512 + srcX;
	pTvW += srcY;

	if (lock_offscreen_surface(&_Pitch, &_pPixels)) //obNT[tFXbN
	{
		_PitchHalf = _Pitch / 2;
		
		//xd̂߂ꂼ̉ʃ[hŁAʁX̃[`gB
		scanLineType = APP_GetScanLineType();
		if (APP_GetTvMode())
		{
			if ((scanLineType != 0)&&(_Magnification >= 2)) //TV Mode x2,x3,x4̂Ƃ
				scanLineType = 4;
			else // x1̂Ƃ̓mXLCƓ
				scanLineType = 0;
		}
		else
		{
			if (scanLineType == 4) //X^[gTV Mode ݒ肵ĂāATvModeꎞIFALSȄԂȂ
				scanLineType = 1; //XyV(c)XLCŕ`
		}
		switch (scanLineType)
		{
			case 0: //mXLC
				switch (_Magnification)
				{
					case 1:	zoom1xNS_dd32(pSrc32, srcY, pTvW, srcH); //32bitJ[
							break;
					case 2:
					case 3:
					case 4:
						zoom2x3x4xNS_dd32(_Magnification, pSrc32, srcY, pTvW, srcH); //32bitJ[
						break;
				}
				break;
			case 1: //cXLC
				switch (_Magnification)
				{
					case 1:	zoom1xNS_dd32(pSrc32, srcY, pTvW, srcH); //32bitJ[
							break;
					case 2:	zoom2x_dd32(pSrc32, srcY, pTvW, srcH); //32bitJ[
							break;
					case 3:	zoom3x_dd32(pSrc32, srcY, pTvW, srcH); //32bitJ[
							break;
					case 4:	zoom4x_dd32(pSrc32, srcY, pTvW, srcH); //32bitJ[
							break;
				}
				break;
			case 2: //̂݃XLC
				switch (_Magnification)
				{
					case 1:	zoom1xNS_dd32(pSrc32, srcY, pTvW, srcH); //32bitJ[
							break;
					case 2:	zoom2xHS_dd32(pSrc32, srcY, pTvW, srcH); //32bitJ[
							break;
					case 3:	zoom3xHS_dd32(pSrc32, srcY, pTvW, srcH); //32bitJ[
							break;
					case 4:	zoom4xHS_dd32(pSrc32, srcY, pTvW, srcH); //32bitJ[
							break;
				}
				break;
			//case 3: //ĉ݃XLCijB5ȍ~ɂGtFNgłB
			case 4: //TV Mode
				switch (_Magnification)
				{
					case 1:	zoom1xNS_dd32(pSrc32, srcY, pTvW, srcH); //32bitJ[BmXLCƓB
							break;
					case 2:	zoom2xTV_dd32(pSrc32, srcY, pTvW, srcH); //32bitJ[
							break;
					case 3:	zoom3xTV_dd32(pSrc32, srcY, pTvW, srcH); //32bitJ[
							break;
					case 4:	zoom4xTV_dd32(pSrc32, srcY, pTvW, srcH); //32bitJ[
							break;
				}
				break;
		}
		
		//bN
		_pD3DSGame->UnlockRect();
		
		//]
		if (executeCode > 0)
			zoom_d3dTensou(pTvW-srcY+(16-MAINBOARD_GetShowOverscanTop()), //pTvW-srcYcŏsrcY𑫂Čɖ߂B
						   srcY+srcH-(16-MAINBOARD_GetShowOverscanTop()),
						   executeCode);
	}
}


//VSync(A҂)sǂݒBVSyncݒłSyncłȂ̏ꍇ͎ňꎞIɃItɂB
void
SCREEND3D_SetSyncTo60HzScreen(
	BOOL	bSyncTo60HzScreen)
{
	BOOL		bPrevSyncTo60HzScreen = _bSyncTo60HzScreen;
	DEVMODE		dm;

	//fBXvČ݂̕\g߂BV-Syncs邩ǂfB
	memset(&dm, 0, sizeof(DEVMODE));
	dm.dmSize = sizeof(DEVMODE);
	EnumDisplaySettings(NULL, ENUM_CURRENT_SETTINGS, &dm);
	if ((dm.dmDisplayFrequency == 60)||(dm.dmDisplayFrequency == 0)) //60Hzsȏꍇ
	{
		_bSyncTo60HzScreen = APP_GetSyncTo60HzScreen();
		APP_EnableVSyncMenu(TRUE); //j[XV
	}
	else
	{
		_bSyncTo60HzScreen = FALSE;
		APP_EnableVSyncMenu(FALSE); //j[XV
	}

	//ݒ肪ύXꂽꍇADirect3DIuWFNgB
	if (_bSyncTo60HzScreen != bPrevSyncTo60HzScreen)
		if (_pD3D != NULL) //IĂ΁BOɌĂ΂ꂽꍇ(App.cĂ΂)͕ϐ̍XV̂݁B
			SCREEND3D_ChangeMode(_Width, _Height, _Magnification, _Flags);
}


//OVBlank҂IԂBv1.28
DWORD
SCREEND3D_GetLastTimeSyncTime()
{
	return _LastTimeSyncTime;
}


//XN[Vbgt@CɏށBv2.12
void
SCREEN3D_WriteScreenshot(
	FILE*	fp,
	Sint32	magnification)
{
	int				i,j;
	D3DLOCKED_RECT	pLockedRect;
	HRESULT			hr;
	LONG			pitch;
	Uint32*			pPixels0;
	Uint32*			pPixels;
	Uint32			BGRR; //Bule,Green,Red,Reserved
	Sint32			width;
	Sint32			height;
	Sint32			left;
	Sint32			top;
	Sint32			w2,h2;
	Sint32			wp;
	Sint32			prevMagnification = _Magnification;

	if (((APP_GetOverscanHideBlackLR())&&(MAINBOARD_GetShowOverscanLeft() == 0))|| //ẼI[o[XL̈ɍѕ\Ăꍇ
		((APP_GetOverscanHideBlackTop())&&(MAINBOARD_GetShowOverscanTop() < 8))) //㑤̃I[o[XL̈ɍѕ\Ăꍇ
			MAINBOARD_SetResolutionChange(TRUE); //`掞ɃS~cȂ悤ɉʑŜNAĂ`悷B

	//\{ݒ肵Aobt@ɍĕ`悷B
	_Magnification = magnification;
	MAINBOARD_DrawScreenshot();
	//_pD3DDev->Presentł̕\XV͍sȂB

	//TCYvZ
	width = APP_GetGameWidth(magnification);
	height = APP_GetGameHeight(magnification);
	wp = 4 - (width*3 % 4); //PC4bytePʂɐ邽߂̒l
	if (wp==4) wp=0;

	//̈ʒuvZ
	if (_Flags & SCREEN_FFULLSCREEN)
	{
		if (APP_GetFullStretched())
		{
			//AXyNg4:3ɕۂ
			if (_Width/4 >= _Height/3)
			{	//ĉقẐŏcƂ
				w2 = (Sint32)((double)(_Height / 3.0 * 4.0 + 0.5));
				left = (_Width - w2) / 2;
				if (MAINBOARD_GetShowOverscanLeft() > 0) //ẼI[o[XL̈\Ȃ
					top = (_Height - (Sint32)((double)_Height * 0.96137 + 0.5)) / 2; //0.96137=224/((268-256)/4*3+224)
				else
					top = 0;
			}
			else
			{	//̂قẐŉƂ
				h2 = (Sint32)((double)(_Width / 4.0 * 3.0 + 0.5));
				left = 0;
				if (MAINBOARD_GetShowOverscanLeft() > 0) //ẼI[o[XL̈\Ȃ
					top = (_Height - (Sint32)((double)h2 * 0.96137 + 0.5)) / 2; //0.96137=224/((268-256)/4*3+224)
				else
					top = (_Height - h2) / 2;
			}
		}
		else if (APP_GetStretched())
		{
			if (MAINBOARD_GetShowOverscanLeft() > 0) //ẼI[o[XL̈\Ȃ
				w2 = (Sint32)(313.24 * (double)magnification + 0.5);
			else
				w2 = 299 * magnification;
			if (APP_GetVStretched()) //cʃ[hȂ
				w2 = (Sint32)((double)w2 * (256.0/336.0));
			//AXyNgTVʂƓ4:3ɁBc̒PCEW224̐{(Q{)ɂ
			left = (_Width - w2) / 2;
			top = (_Height - 224*magnification) / 2;
			if (MAINBOARD_GetShowOverscanTop() > 0) //㑤̃I[o[XL̈\Ȃ
			{
				top -= MAINBOARD_GetShowOverscanTop() * magnification;
				if (top < 0) //ʂ͂ݏoĂ܂ꍇB1440x900,1600x900Ȃǂł蓾B
					top = (_Height - 224*magnification) / 2; //AXyNgۂ߁AI[o[XLJbgB
			}
		}
		else //mXgb`̏ꍇ
		{
			w2 = APP_GetNonstretchedWidth() * magnification;
			if (w2 > _Width) w2 = _Width; //ʂ͂ݏoĂ܂ꍇ́AXgb`(k)đΉB
			left = (_Width - w2) / 2;
			top = (_Height - 224*magnification) / 2;
			if (MAINBOARD_GetShowOverscanTop() > 0) //㑤̃I[o[XL̈\Ȃ
			{
				top -= MAINBOARD_GetShowOverscanTop() * magnification;
				if (top < 0) top = 0; //ʂ͂ݏoĂ܂ꍇ́AXgb`(k)đΉB1440x900,1600x900Ȃǂł蓾B
			}
		}
	}
	else
	{
		left = 0;
		top = 0;
	}

	//Lv`郁bN
	hr = _pD3DSBack->LockRect(&pLockedRect, NULL, 0);
	if (hr != D3D_OK)
	{
		_Magnification = prevMagnification; //\{pϐɖ߂
		MAINBOARD_SetResolutionChange(FALSE); //ɖ߂
		return;
	}

	pitch = pLockedRect.Pitch / 4; //32bitPʂŏ邽߃sb`1/4ɁB
	pPixels0 = (Uint32*)pLockedRect.pBits + pitch*(top+height-1) + left; //ŉit@Cɏo͂čs(BMP̎dl)B

	for (i = 0; i < height; i++)
	{
		pPixels = pPixels0;
		for (j = 0; j < width; j++)
		{
			BGRR = (*pPixels++);
			fwrite(&BGRR, 3, 1, fp); //BGR
		}
		if (wp > 0)
		{	//PC4bytePʂɐ
			BGRR = 0;
			fwrite(&BGRR, wp, 1, fp);
		}
		pPixels0 -= pitch;
	}
	
	//bN
	_pD3DSBack->UnlockRect();

	//\{pϐɖ߂A\ɖ߂B̂Ƃ_pD3DDev->Presentł̕\XVsĂȂ߁AĖ߂Ă΁ALv`ɕ\邱ƂȂB
	_Magnification = prevMagnification;
	MAINBOARD_ScreenUpdate(TRUE);

	MAINBOARD_SetResolutionChange(FALSE); //ɖ߂
}
